const format = require('format');
const {XMLHttpRequest} = require('sdk/net/xhr');

var browsecApi = function() {
  let log = require('logging').create('browsec_api.js');
  var apiPrefix = "https://browsec.com/api/v1/";
  // var apiPrefix = "http://debian:3000/api/v1/";

  return {
    checkCredentials : function (username, password, callback) {
      try {
        // console.group("checkCredentials");

        var data = format("email={0}&password={1}", encodeURIComponent(username), encodeURIComponent(password));

        // var xhr = new XMLHttpRequest();
        var xhr = new XMLHttpRequest();
        xhr.open("POST", apiPrefix + "auth", true);
        xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        xhr.onreadystatechange = function() {
          if (xhr.readyState == 4) {
            if (xhr.status == 200) {
              try {
                var response = JSON.parse(xhr.responseText);
                if (response["status"] == 0) {
                  callback(null, true);
                } else {
                  callback(null, false);
                }
              } catch (e) {
                log.warn(e);
                callback(e);
              }
            } else {
              let error = "POST /auth failed: " + xhr.statusText;
              log.warn(error);
              callback(error);
            }
          }
        };

        xhr.send(data);
      } catch(e) {
        log.warn(e);
        callback(e);
      } finally {
        // console.groupEnd();
      }
    },

    signup : function(callback) {
      try {
        // console.group("Signing up new user");

        var xhr = new XMLHttpRequest();
        xhr.open("POST", apiPrefix + "signup", true);

        xhr.onreadystatechange = function() {
          if (xhr.readyState == 4) {
            if (xhr.status == 200) {
              try {
                var response = JSON.parse(xhr.responseText);
                if (response.status == 0) {
                  callback(null, response.result);
                } else {
                  callback(null, null);
                }
              } catch (e) {
                log.warn(e);
                callback(e);
              }
            } else {
              let error = "POST /signup failed: " + xhr.statusText;
              log.warn(error);
              callback(error);
            }
          }
        }

        xhr.send();
      } catch (e) {
        log.warn(e);
        callback(e);
      }
      finally {
        // console.groupEnd();
      }
    }
  };
}();

module.exports = browsecApi;
