const {Cc, Ci} = require('chrome');

var passwordManager = function() {
  let log = require('logging').create('password_manager.js');
  var loginManagerHost = null;
  var realm = "Browsec";

  return {

    init : function(localProxyHost, localProxyPort) {
      loginManagerHost = "moz-proxy://" + localProxyHost + ":" + localProxyPort;
    },

    getSavedCredentials : function() {
      var loginManager = Cc["@mozilla.org/login-manager;1"].getService(Ci.nsILoginManager);

      var logins = loginManager.findLogins({}, loginManagerHost, null, realm);

      if (logins && logins.length) {
        return logins[0];
      }

      return null;
    },

    deleteCredentials : function() {
      try {
        var loginManager = Cc["@mozilla.org/login-manager;1"].getService(Ci.nsILoginManager);

        var logins = loginManager.findLogins({}, loginManagerHost, null, realm);

        if (logins) {
          for(var i = 0; i < logins.length; i++) {
            loginManager.removeLogin(logins[i]);
          }
        }
      } catch (e) {
        log.error("Error deleting credentials: " + e);
      }
    },

    saveCredentials : function(username, password) {
      try {
        this.deleteCredentials();

        var loginManager = Cc["@mozilla.org/login-manager;1"]
                           .getService(Ci.nsILoginManager);
        var loginInfo = Cc["@mozilla.org/login-manager/loginInfo;1"]
                        .createInstance(Ci.nsILoginInfo);

        loginInfo.init(loginManagerHost, null, realm, username, password, "", "");

        loginManager.addLogin(loginInfo);

      } catch(e) {
        log.error("Error saving credentials: " + e);
      }
    }
  };

}();

module.exports = passwordManager;
