let utils = function() {
  let log = require('logging').create("utils.js", "Warn");

  return {
    copyPrefs : function(prefNames, fromBranch, toBranch) {
      log.debug('copyPrefs CP1: prefnames=', prefNames, ' fromBranch=', fromBranch);
      try {
        for(let i = 0; i < prefNames.length; i++) {
          let prefName = prefNames[i];
          let prefType = fromBranch.getPrefType(prefName);

          switch(prefType) {
            case fromBranch.PREF_STRING:
              log.debug(prefName + " : String");
              toBranch.setCharPref(prefName, fromBranch.getCharPref(prefName));
              break;
            case fromBranch.PREF_INT:
              log.debug(prefName + " : Int");
              toBranch.setIntPref(prefName, fromBranch.getIntPref(prefName));
              break;
            case fromBranch.PREF_BOOL:
              log.debug(prefName + " : Bool");
              toBranch.setBoolPref(prefName, fromBranch.getBoolPref(prefName));
              break;
            case fromBranch.PREF_INVALID:
              log.error(prefName + " : PREF_INVALID");
            default:
              log.error("Unknown pref type");
          }
        }
      } catch (e) {
        log.error("Error in copyPrefs: " + e);
      }
    }
  };
}();

module.exports = utils;
