const {Class} = require('sdk/core/heritage');
const {EventTarget} = require('sdk/event/target');
const {emit} = require('sdk/event/core');

/**
 * EventEmitter should provide the following interface:
 *
 * * `EventEmitter()`: constructs new event emitter
 * * `emitter.on(event, listener)`: adds new listener
 * * `emitter.off(event, listener)`: removes a listener
 * * `emitter.emit(event, ...)`: emits an event
 */
exports.EventEmitter = Class({
  extends: EventTarget,
  initialize: function() {},
  emit: function(event, ...args) {
    emit(this, event, ...args);
  }
});
